#include "iom16.h"
unsigned char pwm = 1;
unsigned char inc = 1; // 0 - , 1 - 

void timer2_init()
{
  OCR2 = 1; //  
  //  ,  OC2 (PD7),    8 
  TCCR2 |= (1 << WGM20) | (1 << COM21) | (1 << CS22);
}

void timer1_init()
{
  OCR1A = 43200; // 32   
  TCCR1A = 0;
  //  ,    8 
  TCCR1B |= (1 << WGM12) | (1 << CS11);
  //     1
  TIMSK |= (1 << OCIE1A);
  SREG |= (1 << 7); // 
}

void io_init()
{
  DDRB = 255;
  PORTB = 0;
  DDRD = (1 << PD7);
  PORTD = 0;
}

void main ()
{
  timer2_init();
  timer1_init();
  io_init();
  while(1)
  {
  }
}

#pragma vector = TIMER1_COMPA_vect
__interrupt void PWM_change()
{
  if (inc == 1)
  {
    if (pwm < 254)
    {
      pwm++;  //   ,    
      OCR2 = pwm;
    }
    else
    {
      inc = 0;
    }
  }
  else
  {
    if (pwm > 1)
    {
      pwm--;  //   ,    
      OCR2 = pwm;
    }
    else
    {
      inc = 1;
    }
  }
}
